SetSensorStateEvent = {};
SetSensorStateEvent_mt = Class(SetSensorStateEvent, Event);

InitEventClass(SetSensorStateEvent, "SetSensorStateEvent");

function SetSensorStateEvent:emptyNew()
	local self = Event:new(SetSensorStateEvent_mt);
	return self;
end

function SetSensorStateEvent:new(object, isSensorLowered)
	local self = SetSensorStateEvent:emptyNew()
	self.object = object;
	self.isSensorLowered = isSensorLowered;
	return self;
end

function SetSensorStateEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.isSensorLowered = streamReadBool(streamId);
	self:run(connection);
end

function SetSensorStateEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.isSensorLowered);
end

function SetSensorStateEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:setSensorState(self.isSensorLowered, true);
    end;
end

function SetSensorStateEvent.sendEvent(vehicle, isSensorLowered, noEventSend)
    if isSensorLowered ~= vehicle.spec_fruitPreparer.isSensorLowered then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(SetSensorStateEvent:new(vehicle, isSensorLowered), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(SetSensorStateEvent:new(vehicle, isSensorLowered));
            end;
        end;
    end;
end