SetUnfoldStateEvent = {};
SetUnfoldStateEvent_mt = Class(SetUnfoldStateEvent, Event);

InitEventClass(SetUnfoldStateEvent, "SetUnfoldStateEvent");

function SetUnfoldStateEvent:emptyNew()
    local self = Event:new(SetUnfoldStateEvent_mt);
    return self;
end

function SetUnfoldStateEvent:new(object, isManualUnloding)
    local self = SetUnfoldStateEvent:emptyNew()
    self.object = object;
    self.isManualUnloding = isManualUnloding;
    return self;
end

function SetUnfoldStateEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId);
    self.isManualUnloding = streamReadBool(streamId);
    self:run(connection);
end

function SetUnfoldStateEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.isManualUnloding);
end

function SetUnfoldStateEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:setUnfoldState(self.isManualUnloding, true);
    end;
end

function SetUnfoldStateEvent.sendEvent(vehicle, isManualUnloding, noEventSend)
    if isManualUnloding ~= vehicle.spec_fruitPreparer.isManualUnloding then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(SetUnfoldStateEvent:new(vehicle, isManualUnloding), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(SetUnfoldStateEvent:new(vehicle, isManualUnloding));
            end;
        end;
    end;
end