SetUnloadStateEvent = {};
SetUnloadStateEvent_mt = Class(SetUnloadStateEvent, Event);

InitEventClass(SetUnloadStateEvent, "SetUnloadStateEvent");

function SetUnloadStateEvent:emptyNew()
    local self = Event:new(SetUnloadStateEvent_mt);
    return self;
end

function SetUnloadStateEvent:new(object, unloadState)
    local self = SetUnloadStateEvent:emptyNew()
    self.object = object;
    self.unloadState = unloadState;
    return self;
end

function SetUnloadStateEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId);
    self.unloadState = streamReadBool(streamId);
    self:run(connection);
end

function SetUnloadStateEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.unloadState);
end

function SetUnloadStateEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:setDischargeLeavesState(self.unloadState, true);
    end;
end

function SetUnloadStateEvent.sendEvent(vehicle, unloadState, noEventSend)
    if unloadState ~= vehicle.spec_fruitPreparer.unloadState then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(SetUnloadStateEvent:new(vehicle, unloadState), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(SetUnloadStateEvent:new(vehicle, unloadState));
            end;
        end;
    end;
end